
#include <stdio.h>
#include <string.h>
#include <fstream.h>

#define MAX_CUVINTE 100
#define MAX_LUNGIME_CUVANT 100
#define MAX_TASTE_ACTIONATE 100

int nr_cuv_dictionar;
char dictionar[MAX_CUVINTE][MAX_LUNGIME_CUVANT + 1];
int nr_taste_actionate;
int comenzi[MAX_TASTE_ACTIONATE];
char *litere = "22233344455566677778889999";

  ofstream g("T9.OUT");
  ifstream f("T9.IN");

void citire(void)
{
  int i;
  f>>nr_cuv_dictionar;
  for (i = 0;i < nr_cuv_dictionar;++i) f>>dictionar[i];
  f>>nr_taste_actionate;
  for (i = 0;i < nr_taste_actionate;++i) f>>comenzi[i];
  f.close();
}

void formeaza(char *cuvant)
{
  int i,j;
  int gasit;
  int bun;

  gasit = 0;
  for (i = 0;i < nr_cuv_dictionar;++i)
  {
    if (strlen(cuvant) != strlen(dictionar[i])) continue;
    bun = 1;
    for (j = 0;j < strlen(cuvant);++j)
      if (cuvant[j] != litere[dictionar[i][j] - 'A'])
      {
	bun = 0;
	break;
      }
    if (bun)
    {
      g<<dictionar[i]<<" ";
      gasit = 1;
      break;
    }
  }
  if (!gasit)
  {
    for (i = 0;i < strlen(cuvant);++i) g<<"*";
    g<<" ";
  }
}

void prelucrare(void)
{
  int numar1,numar2;
  char cuvant[MAX_LUNGIME_CUVANT + 1];

  numar1 = numar2 = 0;
  while (1)
  {
    cuvant[numar2++] = comenzi[numar1++] + '0';
    if (numar1 == nr_taste_actionate || comenzi[numar1] == 1)
    {
      cuvant[numar2] = '\0';
      formeaza(cuvant);
      ++numar1;
      numar2 = 0;
    }
    if (numar1 > nr_taste_actionate)
      break;
  }
  g<<"\n";
  g.close();
}

void main(void)
{
  citire();
  prelucrare();
}
